
g=9.81;
l=0.1;
T=7;
h=0.005;
n=T/h;
y0=[pi/4;0];

fei=@Fei;
Dfei=@DFei;
fcn=@Fcn;
Dfcn=@DFcn;


t=zeros(n+1,1);

yee=zeros(n+1,2);
yee(1,:)=y0';
yei=yee;
ycn=yee;

for i=1:n
   t(i+1)=i*h;
   yee(i+1,:)=yee(i,:)+h*[yee(i,2) -g/l*sin(yee(i,1))];
   yei(i+1,:)=(newton(fei,Dfei,yei(i,:)',h,g,l))';
   ycn(i+1,:)=(newton(fcn,Dfcn,ycn(i,:)',h,g,l))';
end


visualisierePendel(t,yee(:,1),T)
visualisierePendel(t,yei(:,1),T)
visualisierePendel(t,ycn(:,1),T)




function y=newton(F,DF,y,h,g,l)

y0=y;
z=norm(F(y0,y0,h,g,l));
while(z>10^(-8))
    a=DF(y,h,g,l)\F(y,y0,h,g,l);
   y=y-a;
   z=norm(F(y,y0,h,g,l));
end
end

function y=Fei(y,y0,h,g,l)

y=[y(1)-y0(1)-h*y(2);y(2)-y0(2)+h*g/l*sin(y(1))];

end

function  y=DFei(y,h,g,l)

y=[1 -h;h*g/l*cos(y(1)) 1];

end

function y=Fcn(y,y0,h,g,l)

y=[y(1)-y0(1)-h/2*y0(2)-h/2*y(2);y(2)-y0(2)-h/2*(-g/l*sin(y0(1)))-h/2*(-g/l*sin(y(1)))];

end

function y=DFcn(y,h,g,l)

y=[1 -h/2;-h/2*g/l*cos(y(1)) 1];

end

